"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createProdMockServer = void 0;
const mockjs_1 = __importDefault(require("mockjs"));
function createProdMockServer(mockList) {
    // @ts-ignore
    mockjs_1.default.XHR.prototype.__send = mockjs_1.default.XHR.prototype.send;
    // @ts-ignore
    mockjs_1.default.XHR.prototype.send = function () {
        if (this.custom.xhr)
            this.custom.xhr.withCredentials = this.withCredentials || false;
        this.__send.apply(this, arguments);
    };
    for (const { url, method, response, timeout } of mockList) {
        __setupMock__(timeout);
        mockjs_1.default.mock(new RegExp(url), method || 'get', __XHR2ExpressReqWrapper__(response, timeout));
    }
}
exports.createProdMockServer = createProdMockServer;
function __param2Obj__(url) {
    const search = url.split('?')[1];
    if (!search) {
        return {};
    }
    return JSON.parse('{"' +
        decodeURIComponent(search)
            .replace(/"/g, '\\"')
            .replace(/&/g, '","')
            .replace(/=/g, '":"')
            .replace(/\+/g, ' ') +
        '"}');
}
function __XHR2ExpressReqWrapper__(handle, timeout = 0) {
    return function (options) {
        let result = null;
        if (handle instanceof Function) {
            const { body, type, url } = options;
            result = handle({
                method: type,
                body: JSON.parse(body),
                query: __param2Obj__(url),
            });
        }
        else {
            result = handle;
        }
        return mockjs_1.default.mock(result);
    };
}
function __setupMock__(timeout = 0) {
    timeout &&
        mockjs_1.default.setup({
            timeout,
        });
}
