"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.viteMockServe = void 0;
const vite_1 = require("vite");
const createMockServer_1 = require("./createMockServer");
const body_parser_1 = __importDefault(require("body-parser"));
const path_1 = __importDefault(require("path"));
function viteMockServe(opt) {
    const { supportTs } = opt;
    const { injectFile = vite_1.normalizePath(path_1.default.resolve(process.cwd(), `src/main.${supportTs ? 'ts' : 'js'}`)), } = opt;
    let isDev = false;
    let config;
    return {
        name: 'vite:mock',
        enforce: 'pre',
        configResolved(resolvedConfig) {
            config = resolvedConfig;
            isDev = config.command === 'serve' && !config.isProduction;
        },
        configureServer: ({ middlewares }) => {
            const { localEnabled = isDev } = opt;
            if (!localEnabled)
                return;
            createMockServer_1.createMockServer(opt);
            // parse application/x-www-form-urlencoded
            middlewares.use(body_parser_1.default.urlencoded({ extended: false }));
            // parse application/json
            middlewares.use(body_parser_1.default.json());
            middlewares.use(createMockServer_1.requestMiddle(opt));
        },
        async transform(code, id) {
            if (isDev || !id.endsWith(injectFile))
                return code;
            const { prodEnabled = true, injectCode = '' } = opt;
            if (!prodEnabled)
                return;
            return `
      ${code}
      \n
      ${injectCode}
      `;
        },
    };
}
exports.viteMockServe = viteMockServe;
__exportStar(require("./types"), exports);
